]> git.proxmox.com Git - mirror_lxc.git/blob - templates/lxc-plamo.in
Use consistent /proc, /sys and /sys/fs/cgroup (v2)
[mirror_lxc.git] / templates / lxc-plamo.in
1 #!/bin/bash -eu
2
3 #
4 # template script for generating Plamo Linux container for LXC
5 #
6
7 #
8 # lxc: linux Container library
9
10 # Authors:
11 # KATOH Yasufumi <karma@jazz.email.ne.jp>
12 # TAMUKI Shoichi <tamuki@linet.gr.jp>
13
14 # This library is free software; you can redistribute it and/or
15 # modify it under the terms of the GNU Lesser General Public
16 # License as published by the Free Software Foundation; either
17 # version 2.1 of the License, or (at your option) any later version.
18
19 # This library is distributed in the hope that it will be useful,
20 # but WITHOUT ANY WARRANTY; without even the implied warranty of
21 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
22 # Lesser General Public License for more details.
23
24 # You should have received a copy of the GNU Lesser General Public
25 # License along with this library; if not, write to the Free Software
26 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
27
28 # ref. https://github.com/Ponce/lxc-slackware/blob/master/lxc-slackware
29 # lxc-ubuntu script
30
31 # Detect use under userns (unsupported)
32 for arg in "$@"; do
33 [ "$arg" = "--" ] && break
34 if [ "$arg" = "--mapped-uid" -o "$arg" = "--mapped-gid" ]; then
35 echo "This template can't be used for unprivileged containers." 1>&2
36 echo "You may want to try the \"download\" template instead." 1>&2
37 exit 1
38 fi
39 done
40
41 # Make sure the usual locations are in PATH
42 export PATH=$PATH:/usr/sbin:/usr/bin:/sbin:/bin
43
44 [ -r /etc/default/lxc ] && . /etc/default/lxc
45
46 DLSCHEME=${DLSCHEME:-"http"}
47 MIRRORSRV=${MIRRORSRV:-"www.ring.gr.jp"}
48 MIRRORPATH=${MIRRORPATH:-"/pub/linux/Plamo"}
49 CATEGORIES=${CATEGORIES-"00_base 01_minimum"}
50 EXTRACTGRS=${EXTRACTGRS-""}
51 IGNOREPKGS=${IGNOREPKGS-"grub kernel lilo linux_firmware microcode_ctl
52 cpufreqd cpufrequtils gpm"}
53 ADDONPKGS=${ADDONPKGS-"`echo contrib/Hamradio/{morse,qrq}`"}
54
55 download_plamo() {
56 # check the mini plamo was not already downloaded
57 if ! mkdir -p $ptcache ; then
58 echo "Failed to create '$ptcache' directory."
59 return 1
60 fi
61 # download a mini plamo into a cache
62 echo "Downloading Plamo-$release minimal..."
63 cd $ptcache
64 case $DLSCHEME in http) depth=2 ;; ftp) depth=3 ;; esac
65 rej=${IGNOREPKGS%% *} ; [ -n "$rej" ] && rej="$rej-*"
66 if [ `echo $IGNOREPKGS | wc -w` -gt 1 ] ; then
67 for p in ${IGNOREPKGS#* } ; do rej="$rej,$p-*" ; done
68 fi
69 for i in $CATEGORIES ; do
70 wget -nv -e robots=off -r -l $depth -nd -A .tgz,.txz -R "$rej" \
71 -I $MIRRORPATH/Plamo-$release/$arch/plamo/$i \
72 -X $MIRRORPATH/Plamo-$release/$arch/plamo/$i/old \
73 $DLSCHEME://$MIRRORSRV$MIRRORPATH/Plamo-$release/$arch/plamo/$i
74 if [ $? -ne 0 ] ; then
75 echo "Failed to download the rootfs, aborting."
76 return 1
77 fi
78 done
79 for i in $EXTRACTGRS ; do
80 wget -nv -e robots=off -r -l $depth -nd -A .tgz,.txz -R "$rej" \
81 -I $MIRRORPATH/Plamo-$release/$arch/contrib/$i \
82 -X $MIRRORPATH/Plamo-$release/$arch/contrib/$i/old \
83 $DLSCHEME://$MIRRORSRV$MIRRORPATH/Plamo-$release/$arch/contrib/$i
84 if [ $? -ne 0 ] ; then
85 echo "Failed to download the rootfs, aborting."
86 return 1
87 fi
88 done
89 for p in $ADDONPKGS ; do
90 wget -nv -e robots=off -r -l $depth -nd -A "`basename $p`-*" \
91 -I $MIRRORPATH/Plamo-$release/$arch/`dirname $p` \
92 -X $MIRRORPATH/Plamo-$release/$arch/`dirname $p`/old \
93 $DLSCHEME://$MIRRORSRV$MIRRORPATH/Plamo-$release/$arch/`dirname $p`
94 if [ $? -ne 0 ] ; then
95 echo "Failed to download the rootfs, aborting."
96 return 1
97 fi
98 done
99 mv $ptcache $dlcache
100 echo "Download complete."
101 return 0
102 }
103
104 copy_plamo() {
105 # make a local copy of the mini plamo
106 echo "Copying $rtcache to $rootfs..."
107 mkdir -p $rootfs
108 find $rtcache -mindepth 1 -maxdepth 1 -exec cp -a {} $rootfs \; || return 1
109 return 0
110 }
111
112 install_plamo() {
113 mkdir -p @LOCALSTATEDIR@/lock/subsys
114 (
115 if ! flock -n 9 ; then
116 echo "Cache repository is busy."
117 return 1
118 fi
119 echo "Checking cache download in $dlcache..."
120 if [ ! -d $dlcache ] ; then
121 if ! download_plamo ; then
122 echo "Failed to download plamo $release base packages."
123 return 1
124 fi
125 fi
126 # install "installpkg" command temporarily with static linked tar
127 # command into the lxc cache directory to keep the original uid/
128 # gid of files/directories.
129 echo "Installing 'installpkg' command into $dlcache/sbin..."
130 ( cd $dlcache ; tar xpJf hdsetup-*.txz ; rm -rf tmp usr var )
131 sed -i "/ldconfig/!s@/sbin@$dlcache&@g" $dlcache/sbin/installpkg*
132 PATH=$dlcache/sbin:$PATH
133 echo "Installing packages to $rtcache..."
134 if [ ! -d $rtcache ] ; then
135 mkdir -p $rtcache
136 for p in `ls -cr $dlcache/*.t?z` ; do
137 installpkg -root $rtcache -priority ADD $p
138 done
139 fi
140 echo "Copy $rtcache to $rootfs..."
141 if ! copy_plamo ; then
142 echo "Failed to copy rootfs."
143 return 1
144 fi
145 return 0
146 ) 9> @LOCALSTATEDIR@/lock/subsys/lxc-plamo
147 }
148
149 configure_plamo() {
150 # create /dev
151 chmod 666 $rootfs/dev/null
152 mknod -m 666 $rootfs/dev/zero c 1 5
153 chmod 666 $rootfs/dev/random
154 mknod -m 666 $rootfs/dev/urandom c 1 9
155 mkdir -m 755 $rootfs/dev/pts
156 mkdir -m 755 $rootfs/dev/shm
157 chmod 666 $rootfs/dev/tty
158 chmod 600 $rootfs/dev/console
159 mknod -m 666 $rootfs/dev/tty0 c 4 0
160 mknod -m 666 $rootfs/dev/tty1 c 4 1
161 mknod -m 666 $rootfs/dev/tty2 c 4 2
162 mknod -m 666 $rootfs/dev/tty3 c 4 3
163 mknod -m 666 $rootfs/dev/tty4 c 4 4
164 mknod -m 666 $rootfs/dev/full c 1 7
165 mknod -m 600 $rootfs/dev/initctl p
166 mknod -m 666 $rootfs/dev/ptmx c 5 2
167 # suppress log level output for udev
168 sed -i 's/="err"/=0/' $rootfs/etc/udev/udev.conf
169 # /etc/fstab
170 cat <<- "EOF" > $rootfs/etc/fstab
171 none /proc proc defaults 0 0
172 none /sys sysfs defaults 0 0
173 none /dev tmpfs defaults 0 0
174 none /tmp tmpfs defaults 0 0
175 none /dev/pts devpts gid=5,mode=620 0 0
176 none /proc/bus/usb usbfs noauto 0 0
177 none /var/lib/nfs/rpc_pipefs rpc_pipefs defaults 0 0
178 EOF
179 # /etc/inittab
180 cat <<- "EOF" | patch $rootfs/etc/inittab
181 32,33c32,33
182 < # What to do when power fails (shutdown to single user).
183 < pf::powerfail:/sbin/shutdown -f +5 "THE POWER IS FAILING"
184 ---
185 > # What to do when power fails (shutdown).
186 > pf::powerfail:/sbin/shutdown -h +0 "THE POWER IS FAILING"
187 47a48
188 > 1:1235:respawn:/sbin/agetty 38400 console
189 52,53d52
190 < c5:1235:respawn:/sbin/agetty 38400 tty5 linux
191 < c6:12345:respawn:/sbin/agetty 38400 tty6 linux
192 EOF
193 # set the hostname
194 echo "$name" > $rootfs/etc/HOSTNAME
195 # set minimal hosts
196 echo "127.0.0.1 localhost $name" > $rootfs/etc/hosts
197 # configure the network using the dhcp
198 echo "DHCP" > $rootfs/var/run/inet1-scheme
199 # localtime (JST)
200 ln -s ../usr/share/zoneinfo/Asia/Tokyo $rootfs/etc/localtime
201 # disable pam_loginuid.so in /etc/pam.d/login (for libvirt's lxc driver)
202 sed -i '/pam_loginuid/s/^/#/' $rootfs/etc/pam.d/login
203 # glibc configure
204 mv $rootfs/etc/ld.so.conf{.new,}
205 chroot $rootfs ldconfig
206 # root password
207 echo "Setting root password to 'root'..."
208 echo "root:root" | chroot $rootfs chpasswd
209 echo "Please change root password!"
210 # /etc/rc.d/rc.S
211 ed - $rootfs/etc/rc.d/rc.S <<- "EOF"
212 /^mount -w -n -t proc/;/^# ln -s \/bin\/true/-1d
213 /^mknod \/dev\/unikey/;/^# Clean \/etc\/mtab/-2d
214 /^# copy the rules/;/^# Set the hostname/-1d
215 /^# Check the integrity/;/^# Clean up temporary/-1d
216 w
217 EOF
218 # /etc/rc.d/rc.M
219 ed - $rootfs/etc/rc.d/rc.M <<- "EOF"
220 /^# Screen blanks/;/^# Initialize ip6tables/-1d
221 /^# Initialize sysctl/;/^echo "Starting services/-1d
222 /^sync/;/^# All done/-1d
223 w
224 EOF
225 # /etc/rc.d/rc.inet1.tradnet
226 head -n-93 $rootfs/sbin/netconfig.tradnet > /tmp/netconfig.rconly
227 cat <<- EOF >> /tmp/netconfig.rconly
228 PCMCIA=n
229 RC=$rootfs/etc/rc.d/rc.inet1.tradnet
230 IFCONFIG=sbin/ifconfig
231 ROUTE=sbin/route
232 INET1SCHEME=var/run/inet1-scheme
233 IPADDR=127.0.0.1
234 NETWORK=127.0.0.0
235 DHCPCD=usr/sbin/dhclient
236 LOOPBACK=y
237 make_config_file
238 EOF
239 rm -f $rootfs/etc/rc.d/rc.inet1.tradnet
240 sh /tmp/netconfig.rconly
241 rm -f /tmp/netconfig.rconly
242 sed -i '/cmdline/s/if/& false \&\&/' $rootfs/etc/rc.d/rc.inet1.tradnet
243 return 0
244 }
245
246 copy_configuration() {
247 ret=0
248 cat <<- EOF >> $path/config || let ret++
249 lxc.utsname = $name
250 lxc.arch = $arch
251 EOF
252 if [ -f "@LXCTEMPLATECONFIG@/plamo.common.conf" ] ; then
253 cat <<- "EOF" >> $path/config || let ret++
254
255 lxc.include = @LXCTEMPLATECONFIG@/plamo.common.conf
256 EOF
257 fi
258 if [ $ret -ne 0 ] ; then
259 echo "Failed to add configuration."
260 return 1
261 fi
262 return 0
263 }
264
265 post_process() {
266 # nothing do in Plamo Linux
267 true
268 }
269
270 do_bindhome() {
271 # bind-mount the user's path into the container's /home
272 h=`getent passwd $bindhome | cut -d: -f6`
273 mkdir -p $rootfs/$h
274 echo "lxc.mount.entry = $h $rootfs/$h none bind 0 0" >> $path/config
275 # copy /etc/passwd, /etc/shadow, and /etc/group entries into container
276 if ! pwd=`getent passwd $bindhome` ; then
277 echo "Warning: failed to copy password entry for $bindhome."
278 else
279 echo $pwd >> $rootfs/etc/passwd
280 fi
281 echo `getent shadow $bindhome` >> $rootfs/etc/shadow
282 }
283
284 cleanup() {
285 [ -d $dlcache -a -d $rtcache ] || return 0
286 # lock, so we won't purge while someone is creating a repository
287 (
288 if ! flock -n 9 ; then
289 echo "Cache repository is busy."
290 return 1
291 fi
292 echo "Purging the download cache..."
293 rm -rf --one-file-system $dlcache $rtcache || return 1
294 echo "Done."
295 return 0
296 ) 9> @LOCALSTATEDIR@/lock/subsys/lxc-plamo
297 }
298
299 usage() {
300 cat <<- EOF
301 $prog [-h|--help] -p|--path=<path> -n|--name=<name> --rootfs=<rootfs>
302 [-c|--clean] [-r|--release=<release>] [-a|--arch=<arch>]
303 [-b|--bindhome=<user>]
304 release: $release
305 arch: x86 or x86_64: defaults to host arch
306 bindhome: bind <user>'s home into the container
307 EOF
308 }
309
310 prog=`basename $0`
311 path="" ; name="" ; rootfs=""
312 clean=0
313 release=${release:-5.x}
314 arch=`uname -m | sed 's/i.86/x86/'` ; hostarch=$arch
315 bindhome=""
316 sopts=hp:n:cr:a:b:
317 lopts=help,path:,name:,rootfs:,clean,release:,arch:,bindhome:
318 if ! options=`getopt -o $sopts -l $lopts -- "$@"` ; then
319 usage
320 exit 1
321 fi
322 eval set -- "$options"
323 while true ; do
324 case "$1" in
325 -h|--help) usage && exit 0 ;;
326 -p|--path) path=$2 ; shift 2 ;;
327 -n|--name) name=$2 ; shift 2 ;;
328 --rootfs) rootfs=$2 ; shift 2 ;;
329 -c|--clean) clean=1 ; shift 1 ;;
330 -r|--release) release=$2 ; shift 2 ;;
331 -a|--arch) arch=$2 ; shift 2 ;;
332 -b|--bindhome) bindhome=$2 ; shift 2 ;;
333 --) shift 1 ; break ;;
334 *) break ;;
335 esac
336 done
337 if [ $clean -eq 1 -a -z "$path" ] ; then
338 cleanup || exit 1
339 exit 0
340 fi
341 if [ $hostarch == "x86" -a $arch == "x86_64" ] ; then
342 echo "Can't create x86_64 container on x86."
343 exit 1
344 fi
345 if [ -z "$path" ] ; then
346 echo "'path' parameter is required."
347 exit 1
348 fi
349 if [ -z "$name" ] ; then
350 echo "'name' parameter is required."
351 exit 1
352 fi
353 if [ `id -u` -ne 0 ] ; then
354 echo "This script should be run as 'root'."
355 exit 1
356 fi
357 cache=@LOCALSTATEDIR@/cache/lxc
358 ptcache=$cache/partial-${prog##*-}-$release-$arch
359 dlcache=$cache/cache-${prog##*-}-$release-$arch
360 rtcache=$cache/rootfs-${prog##*-}-$release-$arch
361 if [ -z "$rootfs" ] ; then
362 if grep -q "^lxc.rootfs" $path/config ; then
363 rootfs=`awk -F= '/^lxc.rootfs =/{ print $2 }' $path/config`
364 else
365 rootfs=$path/rootfs
366 fi
367 fi
368 if ! install_plamo ; then
369 echo "Failed to install plamo $release."
370 exit 1
371 fi
372 if ! configure_plamo ; then
373 echo "Failed to configure plamo $release for a container."
374 exit 1
375 fi
376 if ! copy_configuration ; then
377 echo "Failed to write configuration file."
378 exit 1
379 fi
380 post_process
381 if [ -n "$bindhome" ] ; then
382 do_bindhome
383 fi
384 if [ $clean -eq 1 ] ; then
385 cleanup || exit 1
386 exit 0
387 fi